#ifndef __HEURISTIC_HPP__
#define __HEURISTIC_HPP__

namespace minmax
{
  template <typename Game>
  class heuristic
  {
  public:
    virtual double value(const Game& game) const = 0;
  };

  template <typename Game>
  class null_heuristic : public heuristic<Game>
  {
    double value(const Game& game) const;
  };

  template <typename Game>
  double null_heuristic<Game>::value(const Game& game) const
  {
    return 0;
  }
}

#endif
