#include "minmax.hpp"
#include "test_minmax.hpp"
#include "connect4.hpp"
#include <iostream>
#include <iomanip>
#include <map>

using namespace std;
using namespace game;

namespace minmax
{
  test_minmax::test_minmax()
  {    
    play();
  }

  template <typename Game>
  int test_minmax::select_move(Game& game)
  {
    cout << game.player_to_string(game.current_player()) << " move: ";
    map<string, int> m;
    for (int i = 0; i < game.number_of_moves(); ++i) 
      {
	m[game.move_to_string(i)] = i;
      }
    string move;
    getline(cin, move);
    game.play(m[move]);
    return m[move];
  }

  void test_minmax::play()
  {
    connect4 c4;
    auto minimax = make_minmax(c4, 2000);
    cout << "play one game" << endl;
    cout << c4 << endl;
    while (!c4.end_of_game())
      {
	cout << "try to prove? (y/n)" << endl;
	string ans;
	getline(cin, ans);
	if (ans == "y")
	  {
	    try
	      {
		int v = minimax.prove();
		if (v == 1) cout << "won position" << endl;
		if (v == -1) cout << "lost position" << endl;
		if (v == 0) cout << "drawn position" << endl;
	      }
	    catch (exception fail)
	      {
		cout << "unable to prove" << endl;
	      }
	  }
	select_move(c4);
	cout << c4 << endl;
      }
    if (c4.value(0) == 1) cout << c4.player_to_string(0) << " won";
    else if (c4.value(1) == 1) cout << c4.player_to_string(1) << " won";
    else cout << "draw";
    cout << endl;
  }

}
